# Index – Symbols

- ! (exclamation)
  - in a command interpreter
  - in curses module
  - in formatted string literal
  - in glob-style wildcards, [1]
  - in string formatting
  - in struct format strings
- ! (pdb command)
- ! patterns
- !=
  - operator, [1]
- " (double quote)
  - string literal
- """
  - string literal
- # (hash)
  - comment, [1], [2]
  - in doctests
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - source encoding declaration
- $ (dollar)
  - environment variables expansion
  - in regular expressions
  - in template strings
  - interpolation in configuration files
- % (percent)
  - datetime format, [1], [2]
  - environment variables expansion (Windows), [1]
  - interpolation in configuration files
  - operator, [1]
  - printf-style formatting, [1]
- %=
  - augmented assignment
- %APPDATA%
- & (ampersand)
  - operator, [1]
- &=
  - augmented assignment
- ' (single quote)
  - string literal
- '''
  - string literal
- () (parentheses)
  - call
  - class definition
  - function definition
  - generator expression
  - in assignment target list
  - in printf-style formatting, [1]
  - in regular expressions
  - tuple display
- (?
  - in regular expressions
- (?!
  - in regular expressions
- (?#
  - in regular expressions
- (?(
  - in regular expressions
- (?:
  - in regular expressions
- (?<!
  - in regular expressions
- (?<=
  - in regular expressions
- (?=
  - in regular expressions
- (?P<
  - in regular expressions
- (?P=
  - in regular expressions
- * (asterisk)
  - function definition
  - import statement
  - in argparse module
  - in assignment target list
  - in AST grammar
  - in expression lists
  - in function calls, [1]
  - in glob-style wildcards, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - operator, [1]
- **
  - function definition
  - in dictionary displays
  - in function calls, [1]
  - in glob-style wildcards
  - operator, [1]
- **=
  - augmented assignment
- *=
  - augmented assignment
- *?
  - in regular expressions
- + (plus)
  - binary operator, [1]
  - in argparse module
  - in doctests
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - unary operator, [1]
- +=
  - augmented assignment
- +?
  - in regular expressions
- , (comma)
  - argument list
  - expression list, [1], [2], [3], [4]
  - identifier list, [1]
  - import statement
  - in dictionary displays
  - in string formatting
  - in target list
  - parameter list
  - slicing
  - with statement
- -
  - python--m-py_compile command line option
- - (minus)
  - binary operator, [1]
  - in doctests
  - in glob-style wildcards, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
  - unary operator, [1]
- --annotate
  - pickletools command line option
- --best
  - gzip command line option
- --buffer
  - unittest command line option
- --catch
  - unittest command line option
- --check-hash-based-pycs default|always|never
  - command line option
- --compact
  - json.tool command line option
- --compress
  - zipapp command line option
- --count
  - trace command line option
- --coverdir=<dir>
  - trace command line option
- --create <tarfile> <source1> ... <sourceN>
  - tarfile command line option
- --create <zipfile> <source1> ... <sourceN>
  - zipfile command line option
- --decompress
  - gzip command line option
- --details
  - inspect command line option
- --disable-ipv6
  - command line option
- --disable-test-modules
  - command line option
- --enable-big-digits=[15|30]
  - command line option
- --enable-framework
  - command line option
- --enable-framework=INSTALLDIR
  - command line option
- --enable-loadable-sqlite-extensions
  - command line option
- --enable-optimizations
  - command line option
- --enable-profiling
  - command line option
- --enable-shared
  - command line option
- --enable-universalsdk
  - command line option
- --enable-universalsdk=SDKDIR
  - command line option
- --exact
  - tokenize command line option
- --exec-prefix=EPREFIX
  - command line option
- --extract <tarfile> [<output_dir>]
  - tarfile command line option
- --extract <zipfile> <output_dir>
  - zipfile command line option
- --failfast
  - unittest command line option
- --fast
  - gzip command line option
- --file=<file>
  - trace command line option
- --filter <filtername>
  - tarfile command line option
- --hardlink-dupes
  - compileall command line option
- --help
  - ast command line option
  - command line option
  - gzip command line option
  - json.tool command line option
  - timeit command line option
  - tokenize command line option
  - trace command line option
  - zipapp command line option
- --ignore-dir=<dir>
  - trace command line option
- --ignore-module=<mod>
  - trace command line option
- --include-attributes
  - ast command line option
- --indent
  - json.tool command line option
- --indent <indent>
  - ast command line option
- --indentlevel=<num>
  - pickletools command line option
- --info
  - zipapp command line option
- --invalidation-mode [timestamp|checked-hash|unchecked-hash]
  - compileall command line option
- --json-lines
  - json.tool command line option
- --list <tarfile>
  - tarfile command line option
- --list <zipfile>
  - zipfile command line option
- --listfuncs
  - trace command line option
- --locals
  - unittest command line option
- --main=<mainfn>
  - zipapp command line option
- --memo
  - pickletools command line option
- --missing
  - trace command line option
- --mode <mode>
  - ast command line option
- --no-ensure-ascii
  - json.tool command line option
- --no-indent
  - json.tool command line option
- --no-report
  - trace command line option
- --no-type-comments
  - ast command line option
- --number=N
  - timeit command line option
- --output=<file>
  - pickletools command line option
- --output=<output>
  - zipapp command line option
- --pattern pattern
  - unittest-discover command line option
- --preamble=<preamble>
  - pickletools command line option
- --prefix=PREFIX
  - command line option
- --process
  - timeit command line option
- --python=<interpreter>
  - zipapp command line option
- --quiet
  - python--m-py_compile command line option
- --repeat=N
  - timeit command line option
- --report
  - trace command line option
- --setup=S
  - timeit command line option
- --sort-keys
  - json.tool command line option
- --start-directory directory
  - unittest-discover command line option
- --summary
  - trace command line option
- --tab
  - json.tool command line option
- --test <tarfile>
  - tarfile command line option
- --test <zipfile>
  - zipfile command line option
- --timing
  - trace command line option
- --top-level-directory directory
  - unittest-discover command line option
- --trace
  - trace command line option
- --trackcalls
  - trace command line option
- --unit=U
  - timeit command line option
- --user-base
  - site command line option
- --user-site
  - site command line option
- --verbose
  - tarfile command line option
  - timeit command line option
  - unittest-discover command line option
- --version
  - command line option
  - trace command line option
- --with-address-sanitizer
  - command line option
- --with-assertions
  - command line option
- --with-builtin-hashlib-hashes=md5,sha1,sha256,sha512,sha3,blake2
  - command line option
- --with-computed-gotos
  - command line option
- --with-cxx-main
  - command line option
- --with-cxx-main=COMPILER
  - command line option
- --with-dbmliborder=db1:db2:...
  - command line option
- --with-dtrace
  - command line option
- --with-ensurepip=[upgrade|install|no]
  - command line option
- --with-framework-name=FRAMEWORK
  - command line option
- --with-hash-algorithm=[fnv|siphash24]
  - command line option
- --with-libc=STRING
  - command line option
- --with-libm=STRING
  - command line option
- --with-libs='lib1 ...'
  - command line option
- --with-lto
  - command line option
- --with-memory-sanitizer
  - command line option
- --with-openssl-rpath=[no|auto|DIR]
  - command line option
- --with-openssl=DIR
  - command line option
- --with-platlibdir=DIRNAME
  - command line option
- --with-pydebug
  - command line option
- --with-readline=editline
  - command line option
- --with-ssl-default-suites=[python|openssl|STRING]
  - command line option
- --with-suffix=SUFFIX
  - command line option
- --with-system-expat
  - command line option

- --with-system-ffi
  - command line option
- --with-system-libmpdec
  - command line option
- --with-tcltk-includes='-I...'
  - command line option
- --with-tcltk-libs='-L...'
  - command line option
- --with-trace-refs
  - command line option
- --with-tzpath=<list of absolute paths separated by pathsep>
  - command line option
- --with-undefined-behavior-sanitizer
  - command line option
- --with-universal-archs=ARCH
  - command line option
- --with-valgrind
  - command line option
- --with-wheel-pkg-dir=PATH
  - command line option
- --without-c-locale-coercion
  - command line option
- --without-decimal-contextvar
  - command line option
- --without-doc-strings
  - command line option
- --without-pymalloc
  - command line option
- --without-readline
  - command line option
- --without-static-libpython
  - command line option
- -=
  - augmented assignment
- ->
  - function annotations, [1]
- -?
  - command line option
- -a
  - ast command line option
  - pickletools command line option
- -B
  - command line option
- -b
  - command line option
  - compileall command line option
  - unittest command line option
- -C
  - trace command line option
- -c
  - trace command line option
  - unittest command line option
  - zipapp command line option
- -c <command>
  - command line option
- -c <tarfile> <source1> ... <sourceN>
  - tarfile command line option
- -c <zipfile> <source1> ... <sourceN>
  - zipfile command line option
- -d
  - command line option
  - gzip command line option
- -d destdir
  - compileall command line option
- -E
  - command line option
- -e
  - tokenize command line option
- -e <tarfile> [<output_dir>]
  - tarfile command line option
- -e <zipfile> <output_dir>
  - zipfile command line option
- -e dir
  - compileall command line option
- -f
  - compileall command line option
  - trace command line option
  - unittest command line option
- -g
  - trace command line option
- -h
  - ast command line option
  - command line option
  - gzip command line option
  - json.tool command line option
  - timeit command line option
  - tokenize command line option
  - zipapp command line option
- -I
  - command line option
- -i
  - command line option
- -i <indent>
  - ast command line option
- -i list
  - compileall command line option
- -J
  - command line option
- -j N
  - compileall command line option
- -k
  - unittest command line option
- -l
  - compileall command line option
  - pickletools command line option
  - trace command line option
- -l <tarfile>
  - tarfile command line option
- -l <zipfile>
  - zipfile command line option
- -m
  - pickletools command line option
  - trace command line option
- -m <mainfn>
  - zipapp command line option
- -m <mode>
  - ast command line option
- -m <module-name>
  - command line option
- -n N
  - timeit command line option
- -O
  - command line option
- -o
  - pickletools command line option
- -o <output>
  - zipapp command line option
- -o level
  - compileall command line option
- -OO
  - command line option
- -p
  - pickletools command line option
  - timeit command line option
  - unittest-discover command line option
- -p <interpreter>
  - zipapp command line option
- -p prepend_prefix
  - compileall command line option
- -q
  - command line option
  - compileall command line option
  - python--m-py_compile command line option
- -R
  - command line option
  - trace command line option
- -r
  - compileall command line option
  - trace command line option
- -r N
  - timeit command line option
- -S
  - command line option
- -s
  - command line option
  - trace command line option
  - unittest-discover command line option
- -s S
  - timeit command line option
- -s strip_prefix
  - compileall command line option
- -T
  - trace command line option
- -t
  - trace command line option
  - unittest-discover command line option
- -t <tarfile>
  - tarfile command line option
- -t <zipfile>
  - zipfile command line option
- -u
  - command line option
  - timeit command line option
- -V
  - command line option
- -v
  - command line option
  - tarfile command line option
  - timeit command line option
  - unittest-discover command line option
- -W arg
  - command line option
- -X
  - command line option
- -x
  - command line option
- -x regex
  - compileall command line option
- . (dot)
  - attribute reference
  - in glob-style wildcards
  - in numeric literal
  - in pathnames, [1]
  - in printf-style formatting, [1]
  - in regular expressions
  - in string formatting
- ..
  - in pathnames
- ...
  - ellipsis literal, [1], [2]
  - in doctests
  - interpreter prompt, [1]
  - placeholder, [1], [2]
- .ini
  - file
- .pdbrc
  - file
- / (slash)
  - function definition
  - in pathnames, [1]
  - operator, [1]
- //
  - operator, [1]
- //=
  - augmented assignment
- /=
  - augmented assignment
- 0b
  - integer literal
- 0o
  - integer literal
- 0x
  - integer literal
- 2-digit years
- 2to3
- : (colon)
  - annotated variable
  - compound statement, [1], [2], [3], [4], [5], [6], [7]
  - function annotations, [1]
  - in dictionary expressions
  - in formatted string literal
  - in SQL statements
  - in string formatting
  - lambda expression
  - path separator (POSIX)
  - slicing
- := (colon equals)
- ; (semicolon), [1]
- < (less)
  - in string formatting
  - in struct format strings
  - operator, [1]
- <<
  - operator, [1]
- <<=
  - augmented assignment
- <=
  - operator, [1]
- <BLANKLINE>
- <file> ... <fileN>
  - python--m-py_compile command line option
- = (equals)
  - assignment statement
  - class definition
  - for help in debugging using string literals
  - function definition
  - in function calls
  - in string formatting
  - in struct format strings
- ==
  - operator, [1]
- > (greater)
  - in string formatting
  - in struct format strings
  - operator, [1]
- >=
  - operator, [1]
- >>
  - operator, [1]
- >>=
  - augmented assignment
- >>>
  - interpreter prompt, [1]
- ? (question mark)
  - in a command interpreter
  - in argparse module
  - in AST grammar
  - in glob-style wildcards, [1]
  - in regular expressions
  - in SQL statements
  - in struct format strings, [1]
  - replacement character
- ??
  - in regular expressions
- @ (at)
  - class definition
  - function definition
  - in struct format strings
  - operator
- [] (square brackets)
  - in assignment target list
  - in glob-style wildcards, [1]
  - in regular expressions
  - in string formatting
  - list expression
  - subscription
- \ (backslash)
  - escape sequence, [1]
  - in pathnames (Windows)
  - in regular expressions, [1], [2]
- \\
  - escape sequence
  - in regular expressions
- \A
  - in regular expressions
- \a
  - escape sequence
  - in regular expressions
- \B
  - in regular expressions
- \b
  - escape sequence
  - in regular expressions, [1]
- \D
  - in regular expressions
- \d
  - in regular expressions
- \f
  - escape sequence
  - in regular expressions
- \g
  - in regular expressions
- \N
  - escape sequence, [1]
  - in regular expressions
- \n
  - escape sequence
  - in regular expressions
- \r
  - escape sequence
  - in regular expressions
- \S
  - in regular expressions
- \s
  - in regular expressions
- \t
  - escape sequence
  - in regular expressions
- \U
  - escape sequence, [1]
  - in regular expressions
- \u
  - escape sequence, [1]
  - in regular expressions
- \v
  - escape sequence
  - in regular expressions
- \W
  - in regular expressions
- \w
  - in regular expressions
- \x
  - escape sequence, [1]
  - in regular expressions
- \Z
  - in regular expressions
- ^ (caret)
  - in curses module
  - in regular expressions, [1]
  - in string formatting
  - marker, [1]
  - operator, [1]
- ^=
  - augmented assignment
- {} (curly brackets)
  - dictionary expression
  - in formatted string literal
  - in regular expressions
  - in string formatting
  - set expression
- | (vertical bar)
  - in regular expressions
  - operator, [1]
- |=
  - augmented assignment
- ~ (tilde)
  - home directory expansion
  - operator, [1]